/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.battle.BattleField
 *  fire.pb.battle.BattleFieldFighter
 *  fire.pb.battle.DemoResult
 *  fire.pb.battle.Fighter
 *  fire.pb.battle.FighterSorter
 *  fire.pb.battle.ResultItem
 *  fire.pb.battle.SubResultItem
 *  fire.pb.util.ParseObjIDInBattle
 *  fire.script.AbstractJSEngine
 *  fire.script.Calculate
 *  xbean.BattleAI
 *  xbean.BattleInfo
 *  xbean.Monster
 *  xbean.Pod
 */
package fire.pb.battle.ai;

import fire.pb.PropRole;
import fire.pb.battle.BattleField;
import fire.pb.battle.BattleFieldFighter;
import fire.pb.battle.DemoResult;
import fire.pb.battle.Fighter;
import fire.pb.battle.FighterSorter;
import fire.pb.battle.ResultItem;
import fire.pb.battle.SubResultItem;
import fire.pb.battle.ai.AIOperation;
import fire.pb.battle.ai.BattleAI;
import fire.pb.battle.ai.BattleAIManager;
import fire.pb.battle.ai.Require;
import fire.pb.battle.ai.TargetFilter;
import fire.pb.util.ParseObjIDInBattle;
import fire.script.AbstractJSEngine;
import fire.script.Calculate;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import xbean.BattleInfo;
import xbean.Monster;
import xbean.Pod;

public class BattleAIAgent {
    protected final int fighterId;
    protected final Fighter fighter;
    protected final BattleInfo battle;
    protected List<xbean.BattleAI> ais = Collections.synchronizedList(new ArrayList());
    protected Map<Integer, List<Integer>> filter2targetIds = new HashMap<Integer, List<Integer>>();
    private List<AIOperation> serverAIActions = new LinkedList<AIOperation>();
    private ResultItem lastresult;

    public BattleAIAgent(Fighter fighter, BattleInfo battle) {
        this.fighter = fighter;
        this.battle = battle;
        this.fighterId = fighter.getFighterId();
        if (this.fighterId != 0) {
            if (fighter.getFightertype() == 1) {
                PropRole prole = new PropRole(fighter.getFighterBean().getUniqueid(), true);
                this.ais = prole.getProperties().getFighteai();
            } else {
                this.ais = ((Monster)battle.getMonsters().get(this.fighterId)).getAis();
            }
        } else {
            this.ais = battle.getBattleais();
        }
    }

    public void setAis(List<xbean.BattleAI> ais) {
        this.ais.clear();
        this.ais.addAll(ais);
    }

    public int getFighterId() {
        return this.fighterId;
    }

    public void setLastResultItem(ResultItem lastresult) {
        this.lastresult = lastresult;
    }

    public ResultItem getLastResultItem() {
        return this.lastresult;
    }

    public int getTargetId(int filterid) {
        List<Integer> targetIds = this.filter2targetIds.get(filterid);
        for (int targetId : targetIds) {
            if (targetId != 1) continue;
            return 1;
        }
        return -1;
    }

    public List<AIOperation> getServerAIActions() {
        return this.serverAIActions;
    }

    public List<AIOperation> getAIActions(int triggerType) {
        this.filter2targetIds.clear();
        LinkedList<AIOperation> actions = new LinkedList<AIOperation>();
        if (this.fighter.getBuffAgent().existBuff(509084)) {
            return actions;
        }
        try {
            if (this.fighterId == 0) {
                this.battle.getEngine().setFighterRound(this.battle.getRound());
            } else {
                this.battle.getEngine().setFighterRound(this.fighter.getFighterBean().getRound());
            }
            ArrayList<Integer> rmIds = new ArrayList<Integer>();
            int aicount = 0;
            ListIterator<xbean.BattleAI> lit = this.ais.listIterator();
            while (lit.hasNext()) {
                if (aicount > 40) {
                    if (!BattleField.logger.isDebugEnabled()) break;
                    BattleField.logger.debug((Object)("AI触发处理时，迭代次数超过40次， BattleCfgId = " + this.battle.getConfigid()));
                    break;
                }
                ++aicount;
                xbean.BattleAI xai = lit.next();
                this.battle.getEngine().setAiRound(this.battle.getRound() - xai.getEnableround() + 1);
                BattleAI ai = BattleAIManager.getInstance().getBattleAIs().get(xai.getId());
                if (ai == null || rmIds.contains(ai.id) || ai.triggerType != triggerType || !this.isTriggered(ai)) continue;
                if (ai.actions.size() > 0) {
                    actions.addAll(ai.actions);
                }
                int addcount = 0;
                for (int enableaiId : ai.enableAIs) {
                    boolean alreadyin = false;
                    for (xbean.BattleAI aai : this.ais) {
                        if (aai.getId() != enableaiId) continue;
                        alreadyin = true;
                        break;
                    }
                    if (alreadyin) continue;
                    xbean.BattleAI xnewai = Pod.newBattleAI();
                    xnewai.setId(enableaiId);
                    xnewai.setEnableround(this.battle.getRound());
                    lit.add(xnewai);
                    ++addcount;
                }
                for (int i = 0; i < addcount; ++i) {
                    lit.previous();
                }
                rmIds.addAll(ai.disableAIs);
                xai.setCount(xai.getCount() + 1);
                if (ai.count <= 0 || xai.getCount() < ai.count) continue;
                rmIds.add(ai.id);
            }
            this.removeAis(rmIds, this.ais);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        Iterator it = actions.iterator();
        while (it.hasNext()) {
            AIOperation action = (AIOperation)it.next();
            if (action.operationType != 2 || action.operationId <= 0 || this.fighter.getFightertype() != 1 || this.fighter.getSkillAgent().hasSkill(action.operationId)) continue;
            it.remove();
        }
        this.changeShape(actions);
        this.changeBG(actions);
        return actions;
    }

    private void removeAis(List<Integer> rmIds, List<xbean.BattleAI> ais) {
        Iterator<xbean.BattleAI> it = ais.iterator();
        while (it.hasNext()) {
            xbean.BattleAI rmai = it.next();
            if (!rmIds.contains(rmai.getId())) continue;
            it.remove();
        }
    }

    private void changeBG(List<AIOperation> actions) {
        for (AIOperation action : actions) {
            if (action.changeBG <= 0) continue;
            this.battle.setBackground(action.changeBG);
        }
    }

    private void changeShape(List<AIOperation> actions) {
        if (this.fighterId == 0) {
            return;
        }
        Monster xmonster = (Monster)this.battle.getMonsters().get(this.fighterId);
        if (xmonster == null) {
            return;
        }
        for (AIOperation action : actions) {
            if (action.changeShape <= 0) continue;
            xmonster.setShape(action.changeShape);
        }
    }

    private boolean isTriggered(BattleAI ai) {
        if (ai == null) {
            return false;
        }
        if ((ai.requires == null || ai.requires.size() < 1) && this.battle.getRound() < 1 && ai.triggerType != BattleAI.TRIGGER_DECISION) {
            return false;
        }
        for (Require require : ai.requires) {
            try {
                Boolean b;
                Iterator<Object> iterator;
                if (require.odds != -1.0f && Math.random() > (double)require.odds) {
                    return false;
                }
                if (require.bounusnum > 0) {
                    int bounusnumcount = 0;
                    iterator = this.battle.getRoleids().values().iterator();
                    while (iterator.hasNext()) {
                        int n = (Integer)iterator.next();
                        Fighter rolefighter = (Fighter)this.battle.getFighterobjects().get(n);
                        if (rolefighter == null || rolefighter.getBounusNum() <= 0) continue;
                        ++bounusnumcount;
                        break;
                    }
                    if (bounusnumcount == 0) {
                        return false;
                    }
                }
                if (require.strBattleRound != null ? !Calculate.getResult((int)this.battle.getRound(), (String)require.strBattleRound) : this.battle.getRound() < 1) {
                    return false;
                }
                if (require.strFighterRound != null && this.fighter != null && !Calculate.getResult((int)this.fighter.getFighterBean().getRound(), (String)require.strFighterRound)) {
                    return false;
                }
                if (require.beActedSkills.size() > 0) {
                    if (!require.beActedSkills.contains(this.getLastResultItem().execute.operationid)) {
                        return false;
                    }
                    boolean hasfighter = false;
                    for (SubResultItem subResultItem : this.getLastResultItem().subresultlist) {
                        for (DemoResult demo : subResultItem.resultlist) {
                            if (demo.targetid != this.getFighterId()) continue;
                            hasfighter = true;
                        }
                    }
                    if (!hasfighter) {
                        return false;
                    }
                }
                if (require.strGoalRequire != null) {
                    HashMap<Integer, List<Integer>> targets = new HashMap<Integer, List<Integer>>();
                    iterator = require.goalFilterIds.iterator();
                    while (iterator.hasNext()) {
                        int n = (Integer)iterator.next();
                        List<Integer> targetFids = this.getTargets(n);
                        if (targetFids == null) {
                            targetFids = new LinkedList<Integer>();
                        }
                        targets.put(n, targetFids);
                    }
                    for (Map.Entry entry : targets.entrySet()) {
                        this.battle.getEngine().put("_" + entry.getKey() + "_", (Object)((List)entry.getValue()).size());
                    }
                    Boolean b2 = require.strGoalRequire.evalToBoolean((AbstractJSEngine)this.battle.getEngine(), this.fighter, null);
                    if (b2 != null && !b2.booleanValue()) {
                        return false;
                    }
                }
                if (require.requireJS == null) continue;
                if (this.fighter != null && this.fighter.getFighterId() > 0) {
                    this.battle.getEngine().put("RoleLv", (Object)this.fighter.getEffectRole().getLevel());
                } else {
                    this.battle.getEngine().put("RoleLv", this.battle.getBattledatas().get(5));
                }
                if ((b = require.requireJS.evalToBoolean((AbstractJSEngine)this.battle.getEngine(), this.fighter, null)) == null || b.booleanValue()) continue;
                return false;
            }
            catch (Exception e) {
                BattleField.logger.error((Object)("错误的JS： " + require.strGoalRequire + "ai" + ai.id), (Throwable)e);
                return false;
            }
        }
        return true;
    }

    public List<Integer> getTargets(int filterId) {
        if (this.filter2targetIds.containsKey(filterId)) {
            return this.filter2targetIds.get(filterId);
        }
        TargetFilter filter = BattleAIManager.getInstance().getTargetFilters().get(filterId);
        if (filter == null) {
            return null;
        }
        ArrayList<Fighter> targets = new ArrayList<Fighter>();
        for (Fighter targetfighter : this.battle.getFighterobjects().values()) {
            int result;
            int relation;
            ParseObjIDInBattle legalRelations;
            Monster monsterbean;
            if (filter.fighterIds.size() != 0 && !filter.fighterIds.contains(targetfighter.getFighterId())) continue;
            int nFightertype = targetfighter.getFighterBean().getFightertype();
            if (filter.monsterIds.size() != 0 && (nFightertype < 3 || !filter.monsterIds.contains((monsterbean = (Monster)this.battle.getMonsters().get(targetfighter.getFighterId())).getMonsterid())) || filter.specialType > 0 && nFightertype > 2 && filter.specialType != (monsterbean = (Monster)this.battle.getMonsters().get(targetfighter.getFighterId())).getSpecialtype() || targetfighter.getEffectRole().getLevel() < filter.minLevel || targetfighter.getEffectRole().getLevel() > filter.maxLevel || filter.hpPercentMin != -1.0f && targetfighter.getEffectRole().getHpPercent() < filter.hpPercentMin || filter.hpPercentMax != -1.0f && targetfighter.getEffectRole().getHpPercent() > filter.hpPercentMax || filter.mpPercentMin != -1.0f && targetfighter.getEffectRole().getMpPercent() < filter.mpPercentMin || filter.mpPercentMax != -1.0f && targetfighter.getEffectRole().getMpPercent() > filter.mpPercentMax || filter.relation != -1 && this.fighter != null && !(this.fighter instanceof BattleFieldFighter) && !(legalRelations = new ParseObjIDInBattle(filter.relation)).validTarget(relation = BattleField.getAimRelation((BattleInfo)this.battle, (int)this.fighter.getFighterId(), (int)targetfighter.getFighterId()))) continue;
            if (!(targetfighter instanceof BattleFieldFighter)) {
                if (this.fighter != null && !(this.fighter instanceof BattleFieldFighter) && filter.unitRelation.size() != 0) {
                    boolean bvalid = false;
                    for (int unitrelation : filter.unitRelation) {
                        int relation2;
                        ParseObjIDInBattle objinbattle;
                        if (unitrelation == 0) {
                            bvalid = true;
                            break;
                        }
                        int relation3 = 512 * (int)Math.pow(2.0, unitrelation - 1);
                        int aimid = targetfighter.getFighterId();
                        if (Math.abs(aimid - this.fighter.getFighterId()) >= 14 || !(objinbattle = new ParseObjIDInBattle(relation3)).validTarget(relation2 = BattleField.getAimRelation((BattleInfo)this.battle, (int)this.fighter.getFighterId(), (int)aimid))) continue;
                        bvalid = true;
                        break;
                    }
                    if (!bvalid) continue;
                }
                boolean bunitcampCheck = false;
                boolean ishost = this.fighter.getFighterBean().getIshost();
                if (this.fighter.getFighterId() == 0) {
                    ishost = true;
                }
                switch (filter.unitCamp) {
                    case 1: 
                    case 5: {
                        if (ishost != targetfighter.getFighterBean().getIshost()) break;
                        if (filter.unitCamp == 5) {
                            if (this.fighter.getFighterBean() == targetfighter.getFighterBean()) break;
                            bunitcampCheck = true;
                            break;
                        }
                        bunitcampCheck = true;
                        break;
                    }
                    case 2: {
                        if (ishost == targetfighter.getFighterBean().getIshost()) break;
                        bunitcampCheck = true;
                        break;
                    }
                    case 3: {
                        if (this.fighter.getFighterId() != targetfighter.getFighterId()) break;
                        bunitcampCheck = true;
                        break;
                    }
                    default: {
                        bunitcampCheck = true;
                    }
                }
                if (!bunitcampCheck) continue;
                if (filter.unitType.size() != 0) {
                    boolean bvalid = false;
                    for (int unittype : filter.unitType) {
                        if (targetfighter.getFighterBean().getFightertype() != unittype || filter.unitMonsterType > 0 && unittype > 3 && unittype <= 6 && filter.unitMonsterType != targetfighter.getFighterBean().getSubtype()) continue;
                        bvalid = true;
                    }
                    if (!bvalid) continue;
                }
            }
            if (!filter.includeDead && !BattleField.checkLiveInBattle((BattleInfo)this.battle, (int)targetfighter.getFighterId()) || !filter.includeHide && this.fighter.getBuffAgent().existBuff(509082) && this.fighter.getBuffAgent().existBuff(509083) && this.fighter.getBuffAgent().existBuff(506201) || filter.resultType > 0 && ((result = ((Integer)this.battle.getRoundresult().get(targetfighter.getFighterId())).intValue()) & filter.resultType) == 0) continue;
            if (filter.sex != -1 || filter.jobs.size() > 0) {
                if (targetfighter.getFighterBean().getFightertype() != 1) continue;
                PropRole prole = new PropRole(targetfighter.getFighterBean().getUniqueid(), false);
                if (filter.sex != -1 && filter.sex != prole.getSex()) continue;
                if (filter.jobs.size() > 0) {
                    boolean bCheck = false;
                    for (int nschool : filter.jobs) {
                        if (nschool != prole.getSchool()) continue;
                        bCheck = true;
                        break;
                    }
                    if (!bCheck) continue;
                }
            }
            if (filter.buffs.size() != 0 && filter.buffjs != null) {
                for (int buffId : filter.buffs) {
                    if (buffId < 1000) {
                        this.battle.getEngine().put("_" + buffId + "_", (Object)targetfighter.getBuffAgent().existBuffByType(buffId));
                        continue;
                    }
                    this.battle.getEngine().put("_" + buffId + "_", (Object)targetfighter.getBuffAgent().existBuff(buffId));
                }
                if (!filter.buffjs.evalToBoolean((AbstractJSEngine)this.battle.getEngine(), null, null).booleanValue()) continue;
            }
            targets.add(targetfighter);
        }
        if (filter.sortAttrId != -1) {
            FighterSorter.sortFightersByAttr(targets, (int)filter.sortAttrId, (boolean)filter.sortMaxMin, (double)0.0);
        }
        LinkedList<Integer> targetIds = new LinkedList<Integer>();
        for (Fighter f : targets) {
            targetIds.add(f.getFighterId());
        }
        this.filter2targetIds.put(filter.id, targetIds);
        return targetIds;
    }
}

